// Import c header files
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>


// Add sdl header files here



// Structs

enum dataTypes {
    ROOT = 0,
    NUMBER = 1,
    TEXT = 2,
    ARRAY = 3
};

typedef struct entry {
    unsigned int tabIndex;
    char* key;
    char* value;
};

typedef struct node {
    unsigned int dataValue = 0;
    unsigned int tabIndex = 0;
    unsigned int entries = 0;
    char* nodeName;
    node* parentNode;
    entry* data = NULL;
};

typedef struct keyValue {
    char* key;
    char* value;
};

typedef struct tag {
    unsigned int dataLength;
    keyValue* data;
    char* name;
    node* parentNode;
};

typedef struct taglist {
    unsigned int tagCount;
    tag* tags;
};

// Function declarations
void cleanupApplication();


// Variables
char* sourceFilePath = "sample.xml";
char* outputFilePath = "output.json";
char* jsonData;
FILE* sourceFile;
FILE* outputFile;

int i = 0, j = 0, k = 0;

int nodeCount = 0;
node* nodes = NULL;

// Main

int main(int argc, char* argv[]) {
    char* arg = (char*) malloc(sizeof (char) * 2);
    char* value;
    atexit(cleanupApplication);

    // Parse the commands given
    for (i = 0; i < argc; i++) {
        if (strlen(argv[i]) > 2) {
            strncpy(arg, argv[i], 2);
            argv[i] += 2;

            value = (char*) realloc(value, sizeof (char) * strlen(argv[i]));
            strcpy(value, argv[i]);

            switch (arg[1]) {
                case 'i':
                    sourceFilePath = (char*) realloc(sourceFilePath, sizeof (char) * strlen(value));
                    strcpy(sourceFilePath, value);
                    printf("Source: %s\n", value);
                    break;
                case 'o':
                    outputFilePath = (char*) realloc(outputFilePath, sizeof (char) * strlen(value));
                    strcpy(outputFilePath, value);
                    printf("Output: %s\n", value);
                default:
                    break;
            }
        }
    }

    if (arg != NULL) {
        free(arg);
    }

    if (value != NULL) {
        free(value);
    }


    // Reading the source file
    if (sourceFilePath != NULL) {

        if (outputFilePath == NULL) {
            outputFilePath = "output.json";
        }

        unsigned int bufferLength = 0;

        // Get and create a buffer for the source data
        sourceFile = fopen(sourceFilePath, "r");
        if (sourceFile == NULL) {
            printf("Error opening input file.\n");
            exit(1);
        } else {
            fseek(sourceFile, 0, SEEK_END);
            bufferLength = ftell(sourceFile);
            rewind(sourceFile);

            char* srcData = (char*) calloc(bufferLength, sizeof (char));
            unsigned int tabIndex = 1;
            unsigned int readingPos = 0;

            char* tagData = (char*) calloc(1, sizeof (char));
            char* tagKey = (char*) calloc(1, sizeof (char));
            char* tagValue = (char*) calloc(1, sizeof (char));

            char* currentTag = (char*) malloc(sizeof (char));
            char* previousTag = (char*) malloc(sizeof (char));
            bool hasOpenTag = false;
            bool hasPreviousTag = false;
            bool isInsideTag = false;
            bool tagHasData = false;
            bool insideKeyValue = false;
            unsigned int openTagIndex = 0, previousTagIndex = 0;

            taglist tagList;
            tagList.tags = (tag*) malloc(sizeof (tag));

            /*
                unsigned int nodeCount = 0;
                node* nodes;

                enum dataTypes {
                    node = 0,
                    number = 1,
                    text = 2,
                    array = 3
                };

                typedef struct entry {
                    unsigned int tabIndex = 0;
                    char* key;
                    char* value;
                };

                typedef struct node {
                    unsigned int dataValue = 0;
                    unsigned int tabIndex = 0;
                    unsigned int entries = 0;
                    char* nodeName;
                    char* nodeData;
                    entry* data;
                };
             */

            unsigned int tagWritePos = 0, dataWritePos = 0;
            char data;
            while (!feof(sourceFile)) {
                data = fgetc(sourceFile);

                switch (data) {
                    case '?':
                        if (tagWritePos == 1) {
                            hasOpenTag = false;
                            tabIndex--;
                        }
                        break;
                    case '\n':
                    case '\r':
                        ++tagWritePos;
                        continue;
                        break;
                    case '<':
                        hasOpenTag = true;
                        isInsideTag = false;
                        continue;
                        break;
                    case '>':
                        if (hasOpenTag) {
                            hasOpenTag = false;
                            currentTag = (char*) calloc(1, sizeof (char));
                            tagWritePos = 0;
                            isInsideTag = true;
                        }

                        tagHasData = false;

                        // React if we are insideKeyValuePair
                        insideKeyValue = false;
                        break;
                    case ' ':
                        if (insideKeyValue) {
                            insideKeyValue = false;
                            tagWritePos = 0;
                        }

                        if (hasOpenTag) {
                            tagList.tags = (tag*) realloc(tagList.tags, sizeof (tag) * (tagList.tagCount + 1));

                            // TODO: START HERE
                            //tagList.tags[tagList.tagCount].name = NULL;
                            tagList.tags[tagList.tagCount].name = (char*) malloc(sizeof (char));
                            //tagList.tags[tagList.tagCount].name = (char*) malloc(strlen(currentTag));
                            strcpy(tagList.tags[tagList.tagCount].name, currentTag);
                            tagHasData = true;
                            tagWritePos = 0;
                            tagList.tagCount++;
                            continue;
                        }
                        break;
                    case '=':
                        if (tagHasData) {
                            insideKeyValue = true;
                            tagWritePos = 0;
                            continue;
                        }
                        break;
                    default:
                        break;
                }

                if (hasOpenTag) {
                    if (!tagHasData) {
                        currentTag = (char*) realloc(currentTag, sizeof (char) * (tagWritePos + 1));
                        currentTag[tagWritePos] = data;
                        ++tagWritePos;
                    } else if (!insideKeyValue) {
                        //tagKey = (char*) realloc(tagKey, sizeof (char) * (tagWritePos + 1));
                        //tagKey[tagWritePos] = data;
                        ++tagWritePos;
                    } else {
                        //tagValue = (char*) realloc(tagValue, sizeof (char) * (tagWritePos + 1));
                        //tagValue[tagWritePos] = data;
                        ++tagWritePos;
                    }
                } else if (!hasOpenTag) {
                    //tagData = (char*) realloc(tagData, sizeof (char) * (dataWritePos + 1));
                    //tagData[dataWritePos] = data;
                    ++dataWritePos;
                }
            }

            for (i = 0; i < tagList.tagCount; i++) {
                printf("%s\n", tagList.tags[i].name);
            }

            fclose(sourceFile);
            free(srcData);
            free(tagData);
            free(currentTag);
            free(previousTag);
        }
    }

    return 0;
}






// Clean up by freeing ressources

void cleanupApplication() {
    printf("\nFreeing ressources...\n");

    if (nodeCount > 0) {
        for (i = 0; i < nodeCount; i++) {
            if (nodes[i].data != NULL) {
                for (j = 0; j < nodes[i].entries; j++) {
                    free(nodes[i].data[j].key);
                    free(nodes[i].data[j].value);
                }
            }
        }
    }

    printf("Clean up done. Exiting. Bye bye...\n");
}
